<template>
  <div class="ele-body">
    <a-card :bordered="false">
      <!-- 表格 -->
      <ele-pro-table
        ref="tableRef"
        row-key="userId"
        :columns="columns"
        :datasource="datasource"
        v-model:selection="selection"
        :scroll="{ x: 2000 }"
        :where="defaultWhere"
        cache-key="proSystemUserTable"
      >
        <template #toolbar>
          <a-space>
            <a-button type="primary" class="ele-btn-icon" @click="openEdit()">
              <template #icon>
                <plus-outlined />
              </template>
              <span>新建</span>
            </a-button>
            <a-button
              danger
              type="primary"
              class="ele-btn-icon"
              @click="removeBatch"
            >
              <template #icon>
                <delete-outlined />
              </template>
              <span>删除</span>
            </a-button>
            <a-button type="dashed" class="ele-btn-icon" @click="openImport">
              <template #icon>
                <upload-outlined />
              </template>
              <span>导入</span>
            </a-button>
            <a-input-search
              allow-clear
              v-model:value="searchText"
              placeholder="请输入关键词"
              @search="reload"
              @pressEnter="reload"
            >
              <template #addonBefore>
                <a-select
                  v-model:value="type"
                  style="width: 100px; margin: -5px -12px"
                >
                  <a-select-option value="nickname">昵称</a-select-option>
                  <a-select-option value="username">账号</a-select-option>
                  <a-select-option value="phone">手机号码</a-select-option>
                  <a-select-option value="userId">用户ID</a-select-option>
                </a-select>
              </template>
            </a-input-search>
          </a-space>
        </template>
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'nickname'">
            <a-tooltip :title="`用户ID：${record.userId}`">
              <a-avatar
                :size="30"
                :src="`${record.avatar}`"
                style="margin-right: 4px"
              >
                <template #icon>
                  <UserOutlined />
                </template>
              </a-avatar>
              <span>{{ record.nickname }}</span>
            </a-tooltip>
          </template>
          <template v-if="column.key === 'type'">
            <a-tag v-if="record.type === 10" color="orange"> 企业用户 </a-tag>
          </template>
          <template v-else-if="column.key === 'roles'">
            <a-tag v-for="item in record.roles" :key="item.roleId" color="blue">
              {{ item.roleName }}
            </a-tag>
          </template>
          <template v-if="column.key === 'balance'">
            <span class="ele-text-success">
              ￥{{ formatNumber(record.balance) }}
            </span>
          </template>
          <template v-if="column.key === 'expendMoney'">
            <span class="ele-text-success">
              ￥{{ formatNumber(record.expendMoney) }}
            </span>
          </template>
          <template v-else-if="column.key === 'status'">
            <a-switch
              :checked="record.status === 0"
              @change="(checked: boolean) => editStatus(checked, record)"
            />
          </template>
          <template v-else-if="column.key === 'action'">
            <a-space>
              <a-button @click="openEdit(record)">修改</a-button>
              <!--              <a-divider type="vertical" />-->
              <a-button @click="resetPsw(record)">重置密码</a-button>
              <!--              <a-divider type="vertical" />-->
              <!--              <a-popconfirm-->
              <!--                placement="topRight"-->
              <!--                title="确定要删除此用户吗？"-->
              <!--                @confirm="remove(record)"-->
              <!--              >-->
              <!--                <a class="ele-text-danger">删除</a>-->
              <!--              </a-popconfirm>-->
            </a-space>
          </template>
        </template>
      </ele-pro-table>
    </a-card>
    <!-- 编辑弹窗 -->
    <user-edit v-model:visible="showEdit" :data="current" @done="reload" />
    <!-- 导入弹窗 -->
    <user-import v-model:visible="showImport" @done="reload" />
    <!-- 用户详情 -->
    <user-info v-model:visible="showInfo" :data="current" @done="reload" />
  </div>
</template>

<script lang="ts" setup>
  import { createVNode, ref, reactive } from 'vue';
  import { message, Modal } from 'ant-design-vue/es';
  import {
    PlusOutlined,
    DeleteOutlined,
    UploadOutlined,
    ExclamationCircleOutlined
  } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro/es';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import { toDateString, messageLoading, formatNumber } from 'ele-admin-pro/es';
  import UserEdit from './components/user-edit.vue';
  import UserImport from './components/user-import.vue';
  import UserInfo from './components/user-info.vue';
  import {
    pageUsers,
    removeUser,
    removeUsers,
    updateUserStatus,
    updateUserPassword
  } from '@/api/system/user';
  import type { User, UserParam } from '@/api/system/user/model';
  import { uuid } from 'ele-admin-pro';
  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);
  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      key: 'index',
      width: 48,
      align: 'center',
      fixed: 'left',
      hideInSetting: true,
      customRender: ({ index }) => index + (tableRef.value?.tableIndex ?? 0)
    },
    {
      title: '操作',
      key: 'action',
      width: 200,
      fixed: 'left',
      align: 'center'
    },
    {
      title: '企业名称',
      key: 'companyName',
      dataIndex: 'companyName',
      width: 220,
      fixed: 'left',
      sorter: true,
      showSorterTooltip: false
    },
    {
      title: '昵称',
      key: 'nickname',
      dataIndex: 'nickname',
      fixed: 'left',
      sorter: true,
      showSorterTooltip: false
    },
    {
      title: '账号',
      dataIndex: 'username',
      sorter: true,
      showSorterTooltip: false
    },
    {
      title: '性别',
      dataIndex: 'sexName',
      width: 80,
      align: 'center',
      sorter: true,
      showSorterTooltip: false
    },
    {
      title: '手机号',
      dataIndex: 'phone',
      sorter: true,
      showSorterTooltip: false
    },
    {
      title: '邮箱',
      dataIndex: 'email',
      sorter: true,
      showSorterTooltip: false
    },
    {
      title: '可用余额',
      dataIndex: 'balance',
      key: 'balance',
      sorter: true,
      showSorterTooltip: false
    },
    {
      title: '实际消费金额',
      dataIndex: 'expendMoney',
      key: 'expendMoney',
      sorter: true,
      showSorterTooltip: false
    },
    {
      title: '用户类型',
      key: 'type',
      dataIndex: 'type',
      sorter: true,
      hideInTable: true
      // customRender: ({ text }) => ['普通用户', '企业用户'][text]
    },
    {
      title: '注册来源',
      key: 'platform',
      dataIndex: 'platform',
      sorter: true,
      customRender: ({ text }) => ['未知', '网站', '小程序', 'APP'][text]
    },
    {
      title: '角色',
      key: 'roles',
      filters: [
        {
          text: '游客',
          value: 6
        },
        {
          text: '普通用户',
          value: 5
        },
        {
          text: '管理员',
          value: 11
        },
        {
          text: '公司职员',
          value: 26
        },
        {
          text: '开发人员',
          value: 12
        }
      ]
    },
    {
      title: '创建时间',
      dataIndex: 'createTime',
      sorter: true,
      showSorterTooltip: false,
      ellipsis: true,
      customRender: ({ text }) => toDateString(text)
    },
    {
      title: '状态',
      key: 'status',
      dataIndex: 'status',
      sorter: true,
      showSorterTooltip: false,
      width: 90,
      align: 'center'
    }
  ]);
  // 表格选中数据
  const selection = ref<User[]>([]);
  // 当前编辑数据
  const current = ref<User | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示用户详情
  const showInfo = ref(false);
  // 是否显示用户导入弹窗
  const showImport = ref(false);
  const type = ref('nickname');
  const searchText = ref('');
  // 默认搜索条件
  const defaultWhere = reactive({
    username: '',
    nickname: ''
  });

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    where = {};
    if (type.value == 'username') {
      where.username = searchText.value;
    }
    if (type.value == 'nickname') {
      where.nickname = searchText.value;
    }
    if (type.value == 'phone') {
      where.phone = searchText.value;
    }
    if (type.value == 'userId') {
      where.userId = searchText.value;
    }
    where.roleId = filters.roles;
    where.type = 10;
    return pageUsers({ ...where, ...orders, page, limit });
  };

  /* 搜索 */
  const reload = (where?: UserParam) => {
    selection.value = [];
    tableRef?.value?.reload({ page: 1, where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: User) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开用户详情弹窗 */
  const openInfo = (row?: User) => {
    current.value = row ?? null;
    showInfo.value = true;
  };

  /* 打开编辑弹窗 */
  const openImport = () => {
    showImport.value = true;
  };

  /* 删除单个 */
  const remove = (row: User) => {
    const hide = messageLoading('请求中..', 0);
    removeUser(row.userId)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的用户吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = messageLoading('请求中..', 0);
        removeUsers(selection.value.map((d) => d.userId))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 重置用户密码 */
  const resetPsw = (row: User) => {
    Modal.confirm({
      title: '提示',
      content: '确定要重置此用户的密码吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        const password = uuid(8);
        updateUserPassword(row.userId, password)
          .then((msg) => {
            hide();
            message.success(msg + '，新密码：' + password);
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 修改用户状态 */
  const editStatus = (checked: boolean, row: User) => {
    const status = checked ? 0 : 1;
    updateUserStatus(row.userId, status)
      .then((msg) => {
        row.status = status;
        message.success(msg);
      })
      .catch((e) => {
        message.error(e.message);
      });
  };
</script>

<script lang="ts">
  export default {
    name: 'SystemUser'
  };
</script>
